﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ExcelRefresh.Processing
{
    public interface IProcessable<T> where T : class, IComparable<T>
    {
        T Item { get; }
        Action<IProcessable<T>> Processor { get; }
        IEnumerable<IProcessingAttempt<T>> Attempts { get; }
        ProcessingStatus Status { get; }
        int MaxAttempts { get; }
        void Process();
    }

}
